/*

Author: Vianeybert Toussaint 
Created: 10/8/2017
Purpose: For Deliverable 3, a homework assignment for students enrolled in Make Course at the University of South Florida. The students will submit a 
         library that controls the HC-SR04 proximity sensor that came with the Arduino Kit. The library will allow for the user to use an CSR04 Ultrasonic 
		 Proximity Sensor to determine if an object is approaching or retracting, and display the distance measured in centimeters in the console. 

*/




#include "HCSR04.h"                          


/*Member definition */
HCSR04ProxSensor:: HCSR04ProxSensor (int echoPin, int triggerPin)
{
  _echoPin =  echoPin;                            //Ensures that the private variable will be used for initialization 
  _triggerPin = triggerPin;
 
  pinMode(_echoPin, INPUT);                       //set pin modes 
  pinMode(_triggerPin, OUTPUT);
}

float HCSR04ProxSensor::readSensor()
{
  
  float cm;
  
  /*Sending out the trigger signal*/
  
  digitalWrite(_triggerPin, HIGH); 
  delayMicroseconds(10); 
  digitalWrite(_triggerPin, LOW);                //at this point the sensor is beginning the measurement process by sending out those 8 ultra sound signals pulses
                                                 //and measures the time until the echo burst comes back. It then calculates that pulse and sends it out to the echo
                                                 //pin.  
  /* obtaining measured distance in time*/
   if(_i==0)
   {
      float distance1 = pulseIn(_echoPin,HIGH); //reads the signal HIGH pulse that was sent by the sensor to the the echo pin, pulseIn returns the pulse length in usec,
      _cm0= distance1/58;                       // distance conversion  
      cm=_cm0;
      _i=1;                                     // ensures that upon the next readsensor() call the distance measured will be stored into another variable 
   }
   else
   {
      float distance2 = pulseIn(_echoPin,HIGH);
      _cm1= distance2/58;
      _i=0;                                     // ensures that upon the next readsensor() call the distance measured will be stored into another variable 
      cm=_cm1;                       
   }
    
  return cm;                 
}

float HCSR04ProxSensor::getLastValue() 

/* obtaining the last measured distance*/
{ 
  if(_i==1)
   {
     if (_cm1==0)                               //Mainly used for the first call since _cm1 is initialized to zero while defining the class, this prevents the 
     {                                          //"retracting" message to automatically generate when initially running the script. 
        _cm1=_cm0;
        return _cm1; 
     }
     else
     {
      return _cm1;  
     } 
   }
   else
   {  
    return _cm0;                         
   }
}
