/*

Author: Vianeybert Toussaint 
Created: 10/8/2017
Purpose: For Deliverable 3, a homework assignment for students enrolled in Make Course at the University of South Florida. The students will submit a 
         library that controls the HC-SR04 proximity sensor that came with the Arduino Kit. The library will allow for the user to use an CSR04 Ultrasonic 
		 Proximity Sensor to determine if an object is approaching or retracting, and display the distance measured in centimeters in the console. 

*/







/*if Statments to prevent repeated compiliation of the header*/

#ifndef HCSR04_h 									 //if header is not defined
#define HCSR04_h                                     //then we define the header file. This ensure that there is no errors when compiling

#include "Arduino.h"                                 //header to include standard libraries in the Arduino IDE 

/*Class defintion*/

class HCSR04ProxSensor                               //This is the header for the class which will allow us to control the proximity sensor
{
    public:                                          //This public access specifier will allow the following members to be visible to the public outside 
                                                     //the class definition

    HCSR04ProxSensor (int echoPin, int triggerPin);  //the constructor, this will allow initialization of members within this class and require the pin numbers
                                                     //for both the trigger and echo pin as arguments to its parameter.
    
    float readSensor();                              //read sensor in cm
  
    float getLastValue();                            //get previous reading to be able to determine whether an object approaches/retracts
  
  private:                                           // The private access specifier will ensure the variables cannot be directly accessed from the outside.

    int _echoPin, _triggerPin, _i;                   // _i, _cm1, _cm0 will be used to allow memory to the program
    float _cm1, _cm0;
    
};                                                  //The semi-colon that is need to end a class declaration.

#endif                                              //terminates the if statements 
